var schedular2App = angular.module("schedular2Mod", []);

schedular2App.controller("schedular2Ctrl", function ($scope, $http) {

  var reqPlan = {
    method: 'POST',
    url: '../Tasks/Service.asmx/ReturnPlannedTasks',
    dataType: 'json',
    headers: { 'Content-Type': 'application/json' },
    data: '',
  }

  var reqScheduled = {
    method: 'POST',
    url: '../Tasks/Service.asmx/ReturnScheduledTasks',
    dataType: 'json',
    headers: { 'Content-Type': 'application/json' },
    data: '',
  }

  $http(reqPlan)
  .then(function (response) {
    $scope.plannedTasks = angular.fromJson(response.data.d);

    //Generate a int id for the planned tasks from the planned task id, as this is a string  
    var idStore = [];
    for (i = 0; i < $scope.plannedTasks.length ; i++) {
      $scope.plannedTasks[i].parentGroupId = 1;
      $scope.plannedTasks[i].resourceId = i;

      idStore.push({ key: $scope.plannedTasks[i].id, value: i });
      //idStore[$scope.plannedTasks[i].id] = i;
    }

    $http(reqScheduled)
      .then(function (response2) {
        $scope.scheduledTasks = angular.fromJson(response2.data.d)

        for (q = 0; q < $scope.scheduledTasks.length; q++) {

          for (id in idStore) {
            if (idStore[id].key == $scope.scheduledTasks[q].PlannedTaskId) {
              $scope.scheduledTasks[q].resourceId = idStore[id].value;
              break;
            }
          }
          //$scope.scheduledTasks[q].resourceId = idStore[$scope.scheduledTasks[q].PlannedTaskId];
          $scope.scheduledTasks[q].parentGroupId = 1;
          $scope.scheduledTasks[q].javaStartDate = new Date(parseInt($scope.scheduledTasks[q].StartDate.substr(6)));
          $scope.scheduledTasks[q].javaEndDate = new Date(parseInt($scope.scheduledTasks[q].EndDate.substr(6)));
        }


        $("#schedule").ejSchedule({
          width: "100%",
          height: "600px",
          orientation: ej.Schedule.Orientation.Horizontal,
          currentView: ej.Schedule.CurrentView.Month,
          group: {
            resources: ["ParentGroups", "PlannedTasks"]
          },
          resources: [
            {
              field: "parentGroupId",
              title: "Parent Groups",
              name: "ParentGroups",
              resourceSettings: {
                dataSource:
                  [
                    {
                      OwnerText: "Tasks",
                      id: 1,
                      OwnerColor: "#f8a398"
                    }, {
                      OwnerText: "People",
                      id: 2,
                      OwnerColor: "#56ca95"
                    }, {
                      OwnerText: "Equipment",
                      id: 3,
                      OwnerColor: "#56ca95"
                    }]
                ,
                text: "OwnerText",
                id: "id",
                color: "OwnerColor"
              }
            }
          ,
          {
            field: "plannedTaskId",
            title: "Planned Tasks",
            name: "PlannedTasks",
            resourceSettings: {
              dataSource: $scope.plannedTasks,
              text: "TaskCode",
              id: "id",
              groupId: "parentGroupId"
            }
          }
          ]
          , appointmentSettings: {
            dataSource:
              $scope.scheduledTasks
            , resourceFields: "parentGroupId, plannedTaskId"
            , description: "TaskCode"
            , id: "id"
            , startTime: "javaStartDate"
            , endTime: "javaEndDate"
            , parentGroupId: "parentGroupId"
            , plannedTaskId: "resourceId"
          }
        });



      })
  .catch(function (response) {
    $scope.tasksListError = response.statusText;
    console.log("This is being hit")
  });

  }).catch(function (response) {
    $scope.tasksListError = response.statusText;
    console.log("This is being hit again")
  });


});